'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.build = build;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _async = require('async');

var _async2 = _interopRequireDefault(_async);

var _path = require('./path.js');

var _path2 = _interopRequireDefault(_path);

var _readFile = require('./readFile.js');

var _readFile2 = _interopRequireDefault(_readFile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function build(pathConfigs, options, callback) {

  var _data = void 0,
      _errors = [];

  _async2.default.eachSeries(pathConfigs, function iterator(pathConfig, cb) {
    if (options.direct) {
      (function () {
        var _pathname = _path2.default.join(pathConfig.root, pathConfig.output);
        _fs2.default.readFile(_pathname, options, function (err, data) {
          if (err) {
            errors.push(err.message);
            cb();
          }
          if (data) {
            callback(null, data, _pathname);
            cb();
          }
        });
      })();
    } else {
      (0, _readFile2.default)(pathConfig, options, function (err, data) {
        if (err) {
          _errors.push(err.message);
          cb();
        }
        if (data) {
          _data = data;
          callback(null, data, pathConfig);
          cb();
        }
      });
    }
  }, function () {
    if (!_data && _errors.length > 0) {
      callback(_errors);
    }
  });
};