'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

(function () {
  var fs = require('fs');
  var chalk = require('chalk');
  var gulp = require('gulp');
  var through = require('through-gulp');
  var $ = require('gulp-load-plugins')();
  var path = require('./path.js');
  var concat = require('./compile/concat.js');
  var html = require('./compile/html.js');
  var webp = require('./compile/webp.js');

  var rType = /\.(\w+)$/i;

  module.exports = function (pathConfig, options, callback) {
    if ((typeof pathConfig === 'undefined' ? 'undefined' : _typeof(pathConfig)) === 'object' && pathConfig.root && pathConfig.input) {
      concat(pathConfig, options, function (err, data) {
        callback(err, data, pathConfig.output);
      });
    } else {
      var type = pathConfig.output.match(rType);

      if (type && type[0]) {

        switch (type[0].toLowerCase()) {

          case '.html':
            // jade会生成 .html 文件所以不需要特殊处理其他 .htm .shtml .xhtml .dhtml 这些文件
            html(pathConfig, options, function (err, data) {
              callback(err, data, pathConfig.output);
            });
            break;
          case '.webp':
            //
            webp(pathConfig, options, function (err, data) {
              callback(err, data, pathConfig.output);
            });
            break;
          default:

            var devDir = pathConfig.config && pathConfig.config.dev_dir ? pathConfig.config.dev_dir : '';
            var publishDir = pathConfig.config && pathConfig.config.publish_dir ? pathConfig.config.publish_dir : './';

            var _pathname = path.join(pathConfig.root, devDir || '', pathConfig.output);

            if (fs.existsSync(_pathname)) {
              global.efesecho.log(chalk.yellow('src:') + ' ' + chalk.grey(_pathname));
              gulp.src(_pathname, {
                base: path.join(pathConfig.root, devDir || '')
              }).pipe($.if(options.publish && pathConfig.config, gulp.dest(publishDir, {
                cwd: pathConfig.root
              }))).pipe(through(function (file) {
                callback(null, file.contents);
                return file;
              }));
              return;
            }

            _pathname = path.join(pathConfig.root, pathConfig.output);
            if (fs.existsSync(_pathname)) {
              gulp.src(_pathname).pipe(through(function (file) {
                callback(null, file.contents, pathConfig.output);
                return file;
              }));
            } else {
              callback(new Error('文件或目录不存在:' + _pathname));
            }
            break;
        }
      } else {

        var _pathname2 = path.join(pathConfig.root, pathConfig.output);
        if (fs.existsSync(_pathname2)) {
          gulp.src(_pathname2).pipe(through(function (file) {
            callback(null, file.contents, pathConfig.output);
            return file;
          }));
        } else {
          callback(new Error('文件或目录不存在:' + _pathname2));
        }
      }
      callback();
    }
  };
})();