'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.match = match;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _md = require('md5');

var _md2 = _interopRequireDefault(_md);

var _fs3 = require('./fs.js');

var _fs4 = _interopRequireDefault(_fs3);

var _path = require('./path.js');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var catchMatchedPathConfigs = [];

function doMatch(requestPath, projectConfigs, spaceDirname) {
  var _matchedPathConfigs = [];

  projectConfigs && projectConfigs.some(function (projectConfig) {
    var matchedPathConfig = {
      root: _path2.default.join(spaceDirname, projectConfig.rewrite.root),
      output: _path2.default.relative(projectConfig.rewrite.request, requestPath),
      config: projectConfig.config
    };

    // 查找到有配置了合并规则的目录，对指定了合并规则的文件赋值合并来源
    if (projectConfig.concatfile) {
      var _concatfile = _fs4.default.readJSONSync(projectConfig.concatfile);
      if (_concatfile) {
        for (var output in _concatfile.pkg) {
          var input = _concatfile.pkg[output];
          if (output === matchedPathConfig.output) {
            matchedPathConfig = {
              root: _path2.default.join(spaceDirname, projectConfig.rewrite.root),
              output: output,
              input: input,
              config: projectConfig.config
            };
          }
        }
      }
    }
    _matchedPathConfigs.push(matchedPathConfig);
  });

  return _matchedPathConfigs;
}

function match(requestHost, requestPath, projectConfigs, spaceDirname) {

  var matchedPathConfigs = catchMatchedPathConfigs[(0, _md2.default)(requestHost + '/' + requestPath)];

  if (!matchedPathConfigs) {
    // 由于需要支持 一个根访问路径 可以配置多个 本地目录，
    // 所以匹配出来的本地路径有可能会有多个。
    // todo 每个查找在第一次大约要使用300ms，有待优化
    var _matchedPathConfigs = doMatch(requestPath, projectConfigs, spaceDirname);
    // 将已经查找到的路径对应关系缓存起来，方便下次调用。
    catchMatchedPathConfigs[(0, _md2.default)(requestHost + '/' + requestPath)] = _matchedPathConfigs;

    return _matchedPathConfigs;
  } else {
    // 更新 concatfile 中的信息
    matchedPathConfigs.map(function (pathConfig) {
      var _concatfile = _fs4.default.readJSONSync(_path2.default.join(pathConfig.root, 'concatfile.json'));
      if (_concatfile) {
        for (var output in _concatfile.pkg) {
          var input = _concatfile.pkg[output];
          if (output === pathConfig.output) {
            pathConfig.output = output;
            pathConfig.input = input;
            return pathConfig;
          }
        }
      }
    });
  }

  return matchedPathConfigs;
}